display "begins and contains" SKIP with NO-LABELS NO-BOX.

DEFINE QUERY q1 FOR Customer.
DEFINE BROWSE b1 QUERY q1 DISPLAY Name
        WITH 3 DOWN TITLE "CONTAINS harry Browse".
DEFINE BUTTON btn LABEL "Ok".

OPEN QUERY q1 FOR EACH Customer WHERE Customer.NAME BEGINS "a". 
OPEN QUERY q1 FOR EACH Customer WHERE NAME CONTAINS "harry".
ENABLE b1.
ENABLE btn.
WAIT-FOR LEAVE OF b1. 

define variable str1 as character no-undo initial "supercalifragi".
define variable str2 as character no-undo initial "super".
define variable str3 as character no-undo initial "rcalif".

pause message "Press SPACE to run begin operator tests: ".

display 
    str1 +
    if str1 begins str2 then " begins with" else " does not begin with " +
    str2 format "x(50)"
    SKIP.
display
    str2 +
    if str2 begins str1 then " begins with" else " does not begin with " +
    str1 format "x(50)"
    SKIP.

/* following won't work:
   CONTAINS allowed only for word indexed field references. (3398) 
display
    str1 +
    if str1 contains str3 then "contains" else "does not contain"
    str3 format "x(50)"
    SKIP.
display
    str3 +
    if str3 contains str1 then "contains" else "does not contain"
    str1 format "x(50)"
    SKIP.
-- end of following won't work */

pause message "Press SPACE to run WHERE begin CLAUSE tests: ".
FIND FIRST Customer WHERE Customer.NAME BEGINS "a".
DISPLAY 
    IF NOT AVAILABLE Customer 
    THEN "Failed" 
    ELSE "BEGINS a FOUND [" + Customer.NAME + "]" FORMAT "x(50)".

/*  Following won't work on 4GL
    CONTAINS may not be used with FIND or old style queries. (3318)*/

pause message "Press SPACE to run FIND FIRST contains tests: ".
FIND FIRST Customer WHERE Customer.NAME CONTAINS "rr".
DISPLAY IF NOT AVAILABLE Customer THEN "Failed" ELSE 
    "FOUND [" + Customer.NAME + "]" FORMAT "x(20)". 
/* end of following won't work */

pause message "Press SPACE to run FOR EACH BEGINS tests: ".
FOR EACH Customer WHERE Customer.Name BEGINS "hA":
    DISPLAY Customer.NAME + " " + Customer.Address FORMAT "x(50)"
        WITH 2 DOWN TITLE "BEGINS hA For EacH".
END.

pause message "Press SPACE to run FOR EACH CONTAINS tests: ".
FOR EACH Customer WHERE Customer.Name CONTAINS "ha*^Bu*":
    DISPLAY Customer.NAME + " " + Customer.Address FORMAT "x(50)"
        WITH 5 DOWN TITLE "CONTAINS har* FOr EacH".
END.

/* here are some errors when parsing the CONTAIN clause: */
/* QBW syntax error - an asterisk (*) is allowed only at the end of a word. (4686) */
/* QBW syntax error - missing word before a '&' '|' or ')'. (2876) */
/* QBW syntax error - unexpected end of query. (2874) */


/*
populate database sample:
insert into customer values( 0, 'George Washington',      '1', 0,  0,  0, '1997.11.01', true );
insert into customer values( 1, 'Thomas Jefferson',       '2', 0,  1,  1, '1997.11.02', false);
insert into customer values( 2, 'James Monroe',           '3', 0,  2,  2, '1997.11.03', true );
insert into customer values( 3, 'Andrew Jackson',         '4', 0,  3,  3, '1997.11.04', false);
insert into customer values( 4, 'William Henry Harrison', '5', 0,  4,  4, '1997.11.05', true );
insert into customer values( 5, 'Abraham Lincoln',        '6', 0,  5,  5, '1997.11.06', false);
insert into customer values( 6, 'Ulysses S. Grant',       '7', 0,  6,  6, '1997.11.07', true );
insert into customer values( 7, 'Benjamin Harrison',      '8', 0,  7,  7, '1997.11.08', false);
insert into customer values( 8, 'Theodore Roosevelt',     '9', 0,  8,  8, '1997.11.09', true );
insert into customer values( 9, 'Herbert Hoover',         'a', 0,  9,  9, '1997.11.10', false);
insert into customer values(10, 'Harry S. Truman',        's', 0, 10, 10, '1997.11.11', true );
insert into customer values(11, 'Dwight D. Eisenhower',   'd', 0, 11, 11, '1997.11.12', false);
insert into customer values(12, 'John F. Kennedy',        'f', 0, 12, 12, '1997.11.13', true );
insert into customer values(13, 'Richard Nixon',          'g', 0, 13, 13, '1997.11.14', false);
insert into customer values(14, 'Gerald Ford',            'h', 0, 14, 14, '1997.11.15', true );
insert into customer values(15, 'Jimmy Carter',           'j', 0, 15, 15, '1997.11.16', false);
insert into customer values(16, 'George Bush',            'k', 0, 16, 16, '1997.11.17', true );
insert into customer values(17, 'Bill Clinton',           'l', 0, 17, 17, '1997.11.18', false);
insert into customer values(18, 'Barack Obama',           '.', 0, 18, 18, '1997.11.19', true );
insert into customer values(19, 'Harry Potter',           ';', 0, 19, 19, '1997.11.20', false);
*/